/****************************************************************************************************************************/
/****************************************************************************************************************************/
/****************************************************************************************************************************/

		PRINT ''
		PRINT ''
		PRINT ''
		PRINT '*********************************************************************************'
		PRINT ''
		PRINT ''
		PRINT '       THE FOLLOWING DATA PROVIDES A HIGHLEVEL OVERVIEW OF THE SERVER BEING REVIEWED.'
		PRINT '       COMPLETED BY: ' + SYSTEM_USER
		PRINT '       Performance Assessment'
		PRINT '       COMPLETED ON: ' + RTRIM(CONVERT(VARCHAR(20),Getdate(), 101))
		PRINT '	   SERVER NAME: ' +  @@SERVERNAME 
		PRINT '	   NOTE: This may be easier to read if use Notepad,' 
		PRINT '			 with smallest font and turn off word wrap.'
		PRINT ''
		PRINT ''
		PRINT ''
		PRINT ''
		PRINT '*********************************************************************************'

/****************************************************************************************************************************/
/****************************************************************************************************************************/
/****************************************************************************************************************************/
/****************************************************************************************************************************/




							
					DECLARE @@IncludeErrorLog	BIT
					SET @@IncludeErrorLog = 0
/***************************************************************************************************/
	
							If @@IncludeErrorLog = 1
								BEGIN
									EXEC master.dbo.xp_readerrorlog
								END
					
					/***************************************************************************************************/
	
		
		
							PRINT '========================================================================================================================='
							PRINT ''
							PRINT ''
							PRINT 'Last restart of the OS'
							PRINT ''
							PRINT ''
							PRINT ''
							SELECT 'Last OS Reboot' AS 'Status'
									, DATEADD(SECOND, (ms_ticks/1000)*(-1), GETDATE()) AS 'Restart Date'
							FROM sys.dm_os_sys_info


						/****************************************************************************************************/
		
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Percent of Cache that is Ad Hoc Queries'
								PRINT ''
								PRINT ''
								PRINT ''

								--https://blog.sqlauthority.com/2017/10/20/sql-server-turn-optimize-ad-hoc-workloads/
								--Pinal Dave

								SELECT 'Percent of Cache - Ad Hoc Queries' AS 'Status',
										AdHoc_Plan_MB, Total_Cache_MB,
										AdHoc_Plan_MB*100.0 / Total_Cache_MB AS 'AdHoc %'
								FROM (
								SELECT SUM(CASE
											WHEN objtype = 'adhoc'
											THEN CONVERT(BIGINT,size_in_bytes)
											ELSE 0 END) / 1048576.0 AdHoc_Plan_MB,
										SUM(CONVERT(BIGINT,size_in_bytes)) / 1048576.0 Total_Cache_MB
								FROM sys.dm_exec_cached_plans) T

					
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Gets Index Fragmentation status, only for greater than 20% fragmented'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT '' 
								CREATE TABLE #IndexFragmentation
										( ItemStatus       NVARCHAR(100),
										  DatabaseName     NVARCHAR(128),
										  TableName        NVARCHAR(128),
										  IndexName        VARCHAR(100),
										  AvgFragmentation DECIMAL(10,2),
										  PageCount        INT,
										  IndexType        VARCHAR(100))
								EXECUTE master.sys.sp_MSforeachdb 'USE [?] INSERT INTO #IndexFragmentation
																SELECT
																   ''Gets Index Fragmentation status, only for greater than 30% fragmented'' AS ''Status''
																 , DB_Name()
																 , OBJECT_NAME(object_id) AS Table_Name
																 , (SELECT name FROM sys.indexes WHERE object_id = i.object_id and index_id = i.index_id) as Index_Name
																 , avg_fragmentation_in_percent, page_count
																 , index_type_desc
																 FROM sys.dm_db_index_physical_stats(DB_ID(), NULL, NULL, NULL, NULL) i
																 WHERE avg_fragmentation_in_percent > 20
																 ORDER BY avg_fragmentation_in_percent DESC '
								Select * from #IndexFragmentation

								DROP TABLE #IndexFragmentation

						/*****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Returns information about the plan guides for each database'
								SET NOCOUNT ON

								PRINT ''
								PRINT ''
								PRINT ''
								CREATE TABLE #PGInfo
										( DBName VARCHAR(128)
										, GuideName VARCHAR(500)
										, CreateDate DATETIME
										, ModifiedDate DATETIME
										, IsEnabled BIT
										, Type VARCHAR(300)
										, QueryStatement NVARCHAR(Max))

								SET NOCOUNT ON	
							EXECUTE master.sys.sp_MSforeachdb 'USE [?] INSERT INTO #PGInfo SELECT 
									DB_Name()
										, Name
										, create_date
										, modify_date
										, is_disabled
										, query_text
										, scope_type
								FROM sys.plan_guides '

								SELECT 'Plan Guide Information'  AS 'Setting'
										, *
								FROM #PGInfo

								IF @@ROWCOUNT = 0
								BEGIN
									SELECT 'No Plan Guides were found in any databases.'
								END

								DROP TABLE #PGInfo
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'This pulls the top 10 queries by CPU time'
								PRINT 'Is you see anything unusual, run it again in SSMS to review the execution plan'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT TOP 10     'Top 10 Queries by CPU Time' AS 'Status'
												, total_worker_time/execution_count AS [Avg CPU Time]
												, qs.creation_time
												, qs.last_execution_time
												, qs.execution_count
												, query_plan
												, qs.total_physical_reads
												, qs.last_physical_reads
												, qs.max_physical_reads
												, qs.total_logical_writes
												, qs.last_logical_writes
												, qs.last_logical_writes
												, qs.max_logical_writes
												, qs.total_logical_reads
												, qs.last_logical_reads
												, qs.last_logical_reads
												, qs.max_logical_reads
								FROM sys.dm_exec_query_stats AS qs  
									CROSS APPLY sys.dm_exec_query_plan(qs.plan_handle)  
								ORDER BY total_worker_time/execution_count DESC
									


						/*************************************************************************************************/
								PRINT '========================================================================================================================='
		
								PRINT ''
			
								PRINT ''
								PRINT 'Information for each database about index seeks and scans'
								SET NOCOUNT ON

								PRINT ''
								PRINT ''
								PRINT '' 
								CREATE TABLE  #SeekScan  (  DBName		VARCHAR(128)
														  , ObjName		VARCHAR(200)
														  , IndexName	VARCHAR(200)
														  , UserSeeks   INT
														  , UserScans	INT
														  , UserLookups INT
														  , UserUpdates INT) 
								EXEC  master.sys.sp_MSforeachdb  '
												 USE [?] 
													INSERT INTO #SeekScan 
													SELECT db_name() 
														 , OBJECT_NAME(S.[OBJECT_ID]) AS [OBJECT NAME]
														 , I.[NAME] AS [INDEX NAME] 
														 , USER_SEEKS 
														 , USER_SCANS 
														 , USER_LOOKUPS 
														 , USER_UPDATES 
													FROM     SYS.DM_DB_INDEX_USAGE_STATS AS S 
																INNER JOIN SYS.INDEXES AS I 
																	ON I.[OBJECT_ID] = S.[OBJECT_ID] 
																		AND I.INDEX_ID = S.INDEX_ID 
													WHERE    OBJECTPROPERTY(S.[OBJECT_ID],''IsUserTable'') = 1 
													ORDER BY OBJECT_NAME(S.[OBJECT_ID])'

								 SELECT  'DB Index Scans and Seeks' AS 'Setting'
											, dbname
											, IndexName
											, UserSeeks
											, UserScans
											, UserLookups
											, UserUpdates
								 FROM  #SeekScan
		 
		 
								 DROP TABLE  #SeekScan

						/*************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Virtual Log File counts for each database'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT '' 
								--From https://gallery.technet.microsoft.com/scriptcenter/SQL-Script-to-list-VLF-e6315249
								-- Kev Riley

								--variables to hold each 'iteration'  
								DECLARE @query VARCHAR(100)  
								DECLARE @dbname SYSNAME  
								DECLARE @vlfs INT  
  
								--table variable used to 'loop' over databases  
								DECLARE @databases TABLE (dbname SYSNAME)  
								INSERT INTO @databases  
								--only choose online databases  
								SELECT name 
								FROM sys.databases 
								WHERE state = 0  
  
								--table variable to hold results  
								DECLARE @vlfcounts TABLE  
										(dbname SYSNAME,  
										 vlfcount INT)  
  
 
 
								--table variable to capture DBCC loginfo output  
								--changes in the output of DBCC loginfo from SQL2012 mean we have to determine the version 
 
								DECLARE @MajorVersion TINYINT  
								SET @MajorVersion = LEFT(CAST(SERVERPROPERTY('ProductVersion') AS NVARCHAR(MAX)),CHARINDEX('.',CAST(SERVERPROPERTY('ProductVersion') AS NVARCHAR(MAX)))-1) 
 
								IF @MajorVersion < 11 -- pre-SQL2012 
								BEGIN 
									DECLARE @dbccloginfo TABLE  
									(  
										fileid			SMALLINT,  
										file_size		BIGINT,  
										start_offset	BIGINT,  
										fseqno			INT,  
										[status]		TINYINT,  
										parity			TINYINT,  
										create_lsn		NUMERIC(25,0)  
									)  
  
									WHILE EXISTS(SELECT TOP 1 dbname 
												 FROM @databases)  
									BEGIN  
  
										SET @dbname = (SELECT TOP 1 dbname 
													   FROM @databases)  
										SET @query = 'DBCC LOGINFO (' + '''' + @dbname + ''') '  
  
										INSERT INTO @dbccloginfo  
										EXEC (@query)  
  
										SET @vlfs = @@rowcount  
  
										INSERT @vlfcounts  
										VALUES(@dbname, @vlfs)  
  
										DELETE FROM @databases WHERE dbname = @dbname  
  
									END --while 
								END 
								ELSE 
								BEGIN 
									DECLARE @dbccloginfo2012 TABLE  
									(  
										RecoveryUnitId		INT, 
										fileid				SMALLINT,  
										file_size			BIGINT,  
										start_offset		BIGINT,  
										fseqno				INT,  
										[status]			TINYINT,  
										parity				TINYINT,  
										create_lsn			NUMERIC(25,0)  
									)  
  
									WHILE EXISTS(SELECT TOP 1 dbname FROM @databases)  
									BEGIN  
  
										SET @dbname = (SELECT TOP 1 dbname FROM @databases)  
										SET @query = 'DBCC LOGINFO (' + '''' + @dbname + ''') '  
  
										INSERT INTO @dbccloginfo2012  
										EXEC (@query)  
  
										SET @vlfs = @@ROWCOUNT  
  
										INSERT @vlfcounts  
										VALUES(@dbname, @vlfs)  
  
										DELETE FROM @databases WHERE dbname = @dbname  
  
									END --while 
								END 
  
								--output the full list  
								SELECT   'Virtual Log File Counts' AS 'Status'
										, dbname
										, vlfcount  
								FROM @vlfcounts  
								ORDER BY vlfcount DESC


						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'TempDB Information'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''

								SELECT    'Free Space in TempDB' AS 'Status'
										, SUM(unallocated_extent_page_count) AS [free pages]
										,(SUM(unallocated_extent_page_count)*1.0/128) AS [free space in MB]
								FROM tempdb.sys.dm_db_file_space_usage;

								SELECT    'Space Allocated for User Objects' AS 'Status'
										, SUM(user_object_reserved_page_count) AS [user object pages used]
										, (SUM(user_object_reserved_page_count)*1.0/128) AS [user object space in MB]
								FROM tempdb.sys.dm_db_file_space_usage;

								SELECT    'Space used by Version Store in TempDB' AS 'Status'
										, SUM(version_store_reserved_page_count) AS [version store pages used]
										, (SUM(version_store_reserved_page_count)*1.0/128) AS [version store space in MB]
								FROM tempdb.sys.dm_db_file_space_usage;


						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Free Log space for all databases'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								DBCC SQLPERF(LOGSPACE);

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Gets the status of Instant File Initialization setting for all databases'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								EXEC sp_readerrorlog 0, 1, 'instant file'
								IF @@ROWCOUNT = 0
									BEGIN
										PRINT 'Could not find the status if Instant File Initialization.'
									END


						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Returns open transactions'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Open Transactions',
									[s_tst].[session_id],
									[s_es].[login_name] AS [Login Name],
									DB_NAME (s_tdt.database_id) AS [Database],
									[s_tdt].[database_transaction_begin_time] AS [Begin Time],
									[s_tdt].[database_transaction_log_bytes_used] AS [Log Bytes],
									[s_tdt].[database_transaction_log_bytes_reserved] AS [Log Rsvd],
									[s_est].text AS [Last T-SQL Text],
									[s_eqp].[query_plan] AS [Last Plan]
								FROM sys.dm_tran_database_transactions [s_tdt]
									INNER JOIN sys.dm_tran_session_transactions [s_tst]
										ON [s_tst].[transaction_id] = [s_tdt].[transaction_id]
									INNER JOIN sys.[dm_exec_sessions] [s_es]
										ON [s_es].[session_id] = [s_tst].[session_id]
									INNER JOIN sys.dm_exec_connections [s_ec]
										ON [s_ec].[session_id] = [s_tst].[session_id]
									LEFT OUTER JOIN sys.dm_exec_requests [s_er]
										ON [s_er].[session_id] = [s_tst].[session_id]
									CROSS APPLY sys.dm_exec_sql_text ([s_ec].[most_recent_sql_handle]) AS [s_est]
									OUTER APPLY sys.dm_exec_query_plan ([s_er].[plan_handle]) AS [s_eqp]
								ORDER BY
									[Begin Time] ASC;


						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Key Memory Counters'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''

								SELECT counter_name
										, cntr_value AS 'CounterValue'
										, CASE WHEN counter_name = 'Page life expectancy'      THEN 'PLE Should be above 300'
											   WHEN counter_name = 'Target Server Memory (KB)' THEN 'How much memory SQL Server would like to use to operate efficiently'
											   WHEN counter_name = 'Total Server Memory (KB)'  THEN 'Current amount of memory that SQL Server is using'
										 END  AS 'Note'
										, 'If Total Server memory is greater than Target Server memory, could be a sign of memory pressure' AS 'Advice'
								FROM sys.dm_os_performance_counters
								WHERE counter_name IN (  'Page Life Expectancy'
													   , 'Total Server Memory (KB)'
													   , 'Target Server Memory (KB)')
												AND instance_name = ''
								ORDER BY counter_name

		 
								--Should be zero
								SELECT    'Memory Grants Pending' AS 'Status'
										,  Counter_Name
										,  Instance_Name
										,  Cntr_value
										, 'Review LazyWrites, PLE and Free List Stalls if high, should be 0' AS 'Note'
								FROM sys.dm_os_performance_counters
								WHERE counter_name = 'Memory Grants pending'


								--the number of requestsfor available database pages are suspended 
								--requests stall because there are 
								--no buffers available
								--Should be 2 or less
								DECLARE @FLS BIGINT
								SELECT @FLS = cntr_value
								FROM sys.dm_os_performance_counters
								WHERE counter_name = 'Free list stalls/sec'

								WAITFOR DELAY '00:02:00';

								SELECT    'Free List Stalls/Sec' AS 'Status'
										, (cntr_value - @FLS) / 120  AS 'Free List Stalls/Sec'
										, 'Review LazyWrites, PLE and Memory Grants Pending if high, should be less than 2' AS 'Note'
								FROM sys.dm_os_performance_counters
								WHERE counter_name = 'Free list stalls/sec'



								--Lazy Writer process is moving dirty pages from the buffer to disk in order to free up buffer space
								--from the buffer to disk
								--Should be as close to 0 as possible


								--Average Per Second

								DECLARE @LazyWrites bigint;
								SELECT @LazyWrites = cntr_value
								FROM sys.dm_os_performance_counters
								WHERE counter_name = 'Lazy writes/sec';
 
								WAITFOR DELAY '00:02:00';
 
								SELECT   'Lazy Writes/Sec' AS 'Status'
									   , (cntr_value - @LazyWrites) / 120 AS 'LazyWrites/sec'
									   , 'Review Free List Stalls, PLE and Memory Grants Pending if high, should be close to Zero' AS 'Note'
								FROM sys.dm_os_performance_counters
								WHERE counter_name = 'Lazy writes/sec';




								
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Wait Information'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Wait Information' AS 'Description'
								    , *
									, CASE WHEN wait_type = 'RESOURCE_SEMAPHORE' AND Waiting_tasks_count > 0 
											THEN 'Review Memory Utilization' ELSE 'No issues with this wait type'
									  END AS 'Additional Information'
								FROM sys.dm_os_wait_stats
								WHERE wait_type IN ('RESOURCE_SEMAPHORE')
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Alert Information'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Alert Information'  AS 'Setting'
										, [name] AS [AlertName]
										, [event_source] AS [EventSource]
										, [message_id] AS [MessageID] 
										, [severity] AS [Enabled]
										, [has_notification] AS	[HasNotification]
										, [delay_between_responses] AS [DelayBetweenResponses]
										, [occurrence_count] AS [OccuranceCount] 
										, [last_occurrence_date] AS [LastOccuranceDate]
										, [last_occurrence_time] AS [LastOccuranceTime]
								FROM [msdb].[dbo].[sysalerts] ORDER BY AlertName
								IF @@ROWCOUNT = 0
									BEGIN
										SELECT 'No Alerts were found' AS 'Status'
									END




						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Get Activity By Hour, past 8 weeks, only for databases with transaction log backups'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Activity by Hour'  AS 'Setting',
									   @@servername AS 'Server', 
									   a.database_name,
									   DATEPART(HOUR,a.backup_start_date) AS 'Hour',
									   convert(int,AVG(CASE WHEN charindex('Monday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End))  as 'Mon_size(MB)',
									   convert(int,AVG(CASE WHEN charindex('Tuesday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Tue_size(MB)',
									   convert(int,AVG(CASE WHEN charindex('Wednesday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Wed_size(MB)',
									   convert(int,AVG(CASE WHEN charindex('Thursday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Thu_size(MB)',
									   convert(int,AVG(CASE WHEN charindex('Friday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Fri_size(MB)',
									   convert(int,AVG(CASE WHEN charindex('Saturday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Sat_size(MB)',
									   convert(int,AVG(CASE WHEN charindex('Sunday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Sun_size(MB)'
									   ,MIN(a.backup_start_date ) as 'From:'
									   ,MAX(a.backup_start_date ) as 'To:'
									   ,COUNT(*)
								FROM msdb.dbo.backupset a (NOLOCK)
								WHERE a.type = 'L' --log backups
									AND a.backup_start_date 
										BETWEEN DATEADD(WEEK, DATEDIFF(WEEK,0,GETDATE())-8 ,0) AND GETDATE() --8 WEEKs back
								GROUP BY a.database_name, 
								  DATEPART(HOUR,a.backup_start_date)
								ORDER BY a.database_name, 
								  DATEPART(HOUR,a.backup_start_date)

								IF @@Rowcount = 0
									BEGIN
										Select 'No Transaction Log backups are taking place' AS 'Status'
									END



						
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Duration of backups'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT TOP 100
									 'Backup Duration and information'  AS 'Setting',
									 s.database_name,
									 m.physical_device_name,
									 CAST(CAST(s.backup_size / 1000000 AS INT) AS VARCHAR(14)) + ' ' + 'MB' AS bkSize,
									 CAST(DATEDIFF(second, s.backup_start_date,
									 s.backup_finish_date) AS VARCHAR(4)) + ' ' + 'Seconds' TimeTaken,
									 s.backup_start_date,
									 s.backup_finish_date,
									 CAST(s.first_lsn AS VARCHAR(50)) AS first_lsn,
									 CAST(s.last_lsn AS VARCHAR(50)) AS last_lsn,
									 CASE s.[type]
									 WHEN 'D' THEN 'Full'
									 WHEN 'I' THEN 'Differential'
									 WHEN 'L' THEN 'Transaction Log'
									 END AS BackupType,
									 s.server_name,
									 s.recovery_model
								 FROM msdb.dbo.backupset s
									INNER JOIN msdb.dbo.backupmediafamily m ON s.media_set_id = m.media_set_id
								 ORDER BY backup_start_date DESC, backup_finish_date
		

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Run only if requested, for each database, Find the most executed stored procedure(s).'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 	  'Most Executed Stored Procs - Run for Each DB if needed'  AS 'Setting'
										 , CONVERT(VARCHAR(60),DB_NAME(SQTX.DBID)) AS [DBNAME] 
										 , CONVERT(VARCHAR(60),OBJECT_SCHEMA_NAME(SQTX.OBJECTID,DBID)) AS [SCHEMA]
										 , CONVERT(VARCHAR(60),OBJECT_NAME(SQTX.OBJECTID,DBID)) AS [STORED PROC]  
										 , MAX(CPLAN.USECOUNTS)  [EXEC COUNT]     
								FROM	 sys.dm_exec_cached_plans  CPLAN  
												CROSS APPLY sys.dm_exec_sql_text(CPLAN.PLAN_HANDLE) SQTX  
								WHERE	 DB_NAME(SQTX.DBID) IS NOT NULL AND CPLAN.OBJTYPE = 'PROC' 
								GROUP BY CPLAN.PLAN_HANDLE 
											,DB_NAME(SQTX.DBID) 
												,OBJECT_SCHEMA_NAME(OBJECTID,SQTX.DBID)  
													,OBJECT_NAME(OBJECTID,SQTX.DBID)  
								ORDER BY MAX(CPLAN.USECOUNTS) DESC 

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Jobs that have failed in past 30 Days'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT DISTINCT 'Jobs that have failed in past 30 Days' AS 'State'
												, b.server
												, a.name 'Job_Name' 
												, b.step_id 
												, ' Jobs run_status :'+ CONVERT(CHAR(2), b.run_status) +' ,' + b.message AS message
												, b.run_date,b.run_time
												, b.run_duration 
								 FROM msdb.dbo.sysjobs a 
									INNER JOIN msdb.dbo.sysjobhistory b 
										ON a.job_id = b.job_id 
									INNER JOIN msdb.dbo.sysjobsteps D 
										ON a.job_id = D.job_id 
								 WHERE b.run_status IN(1,0) 
									AND D.last_run_date <> 0 
										AND D.last_run_time <> 0 
											AND (message LIKE '%(10) without succeeding%' OR message LIKE '%failed%') 
												AND message NOT LIKE '%The step succeeded%' 
													AND b.instance_id IN ( SELECT MAX(instance_id) 
																		   FROM msdb.dbo.sysjobhistory C 
																		   WHERE C.job_id=a.job_id 
																		   GROUP BY run_date, step_id ) 
														AND b.run_date >= CONVERT(CHAR(10),GETDATE()-30,112)
								 IF @@Rowcount = 0
										BEGIN
											Select 'No Jobs have failed in past 30 days' AS 'Status'
										END


									
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Finds any active transactions for the active database'
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Active Transactions'  AS 'Setting', * 
								FROM sys.dm_tran_session_transactions 


						/****************************************************************************************************/

								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Information regarding the location of Column Store Indexes'

								DECLARE @SQLVersion10 VARCHAR(100)

								SELECT @SQLVersion10 = CONVERT(VARCHAR(100),SERVERPROPERTY('productversion') )

								IF LEFT(@SQLVersion10, 2) NOT IN (12, 13)
								SET NOCOUNT ON
										PRINT ''
										PRINT ''
										PRINT ''



											IF  LEFT(@SQLVersion10, 2) in ('11','12', '13', '14')
												BEGIN
														CREATE TABLE #CSIInventory
															( Setting		VARCHAR(128)
															, DBName		VARCHAR(128)
															, SchemaName	VARCHAR(128)
															, TableName		VARCHAR(128)
															, IndexName		VARCHAR(300)
															, IndexType		VARCHAR(300))


														EXEC Master.sys.sp_MSForeachDB 
														@command1='USE [?]; Insert #CSIInventory
																		SELECT ''Column Store Indexes''
																				, db_name()
																				, OBJECT_SCHEMA_NAME(OBJECT_ID)
																				, OBJECT_NAME(OBJECT_ID)
																				, i.name 
																				, i.type_desc
																		FROM sys.indexes AS i 
																		WHERE is_hypothetical = 0 
																			AND i.type_desc IN (''CLUSTERED COLUMNSTORE'',''NONCLUSTERED COLUMNSTORE'')'
				
													SELECT * FROM #CSIInventory
													IF @@Rowcount = 0
															BEGIN
																SELECT 'No Columnstore Indexes were found' AS 'Status'
															END
												END
											ELSE
												BEGIN
													IF OBJECT_ID('tempdb.dbo.#CSIInventory', 'U') IS NOT NULL
														BEGIN
															DROP TABLE #CSIInventory
														END
													SELECT 'This version of SQL Server does not support Columnstore indexes' AS 'Status'
												END


						/****************************************************************************************************/

								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''

								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Potential missing indexes'
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
										CREATE TABLE #MissingIndex
														(	  Setting								VARCHAR(50)
															, DatabaseName							VARCHAR(200)
															, SchemaName							VARCHAR(200)
															, ObjName								VARCHAR(200)
															, ObjType								VARCHAR(200)
															, EqualityColumns						VARCHAR(4000)
															, InequalityColumns						VARCHAR(4000)
															, IncludeColumns						VARCHAR(4000)
															, ExpectedSeeksByUserQueries			BIGINT
															, ExpectedScansByUserQueries			BIGINT
															, ExpectedLastIndexSeekByUserQueries	DATETIME
															, ExpectedLastIndexScanByUserQueries	DATETIME
															, ExpectedAvgUserQueriesCostReduction	DECIMAL(19,4)
															, ExpectedAvgUserQueriesBenefitPct		DECIMAL(9, 2))

											EXEC Master.sys.sp_MSForeachDB 
															@command1='USE [?]; Insert #MissingIndex
																SELECT ''Potential Missing Indexes''
																   , DB_NAME() 
																   , SCHEMA_NAME(Obj.schema_id) AS SchemaName
																   , Obj.name AS ObjectName
																   , CASE Obj.type
																		  WHEN ''U'' THEN ''Table''
																		  WHEN ''V'' THEN ''View''
																		  ELSE ''Unknown''
																	 END AS ObjectType
																   , mid.equality_columns AS EqualityColumns
																   , mid.inequality_columns AS InequalityColumns
																   , mid.included_columns AS IncludedColumns
																   , igs.user_seeks AS ExpectedIndexSeeksByUserQueries
																   , igs.user_scans AS ExpectedIndexScansByUserQueries
																   , igs.last_user_seek AS ExpectedLastIndexSeekByUserQueries
																   , igs.last_user_scan AS ExpectedLastIndexScanByUserQueries
																   , igs.avg_total_user_cost AS ExpectedAvgUserQueriesCostReduction
																   , igs.avg_user_impact AS ExpectedAvgUserQueriesBenefitPct
																FROM 
																  sys.dm_db_missing_index_details AS mid
																		LEFT JOIN sys.dm_db_missing_index_groups AS mig
																			ON mid.index_handle = mig.index_handle
																		LEFT JOIN sys.dm_db_missing_index_group_stats AS igs
																			ON mig.index_group_handle = igs.group_handle
																		INNER JOIN sys.objects AS obj
																			ON mid.object_id = obj.object_id
																WHERE
																   mid.database_id = DB_ID()  
																		AND obj.type IN (''U'',''V'')     
																			AND obj.is_ms_shipped = 0x0' 
													
												SELECT * FROM #MissingIndex

												IF @@ROWCOUNT = 0
													BEGIN
														PRINT 'No Potential Missing indexes found'
													END
						
						
												DROP TABLE #MissingIndex 

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''

								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'What SPIDs are using the TempDB'
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''

												SELECT   'What is currently using the TempDB' AS 'Status'
														, R1.session_id
														, R1.request_id
														, R1.Task_request_internal_objects_alloc_page_count
														, R1.Task_request_internal_objects_dealloc_page_count
														, R1.Task_request_user_objects_alloc_page_count
														, R1.Task_request_user_objects_dealloc_page_count
														, R3.Session_request_internal_objects_alloc_page_count 
														, R3.Session_request_internal_objects_dealloc_page_count
														, R3.Session_request_user_objects_alloc_page_count
														, R3.Session_request_user_objects_dealloc_page_count
														, R2.sql_handle
														, RL2.text as SQLText
														, R2.statement_start_offset
														, R2.statement_end_offset
														, R2.plan_handle FROM (SELECT session_id
																					, request_id
																					, SUM(internal_objects_alloc_page_count) AS Task_request_internal_objects_alloc_page_count
																					, SUM(internal_objects_dealloc_page_count)AS Task_request_internal_objects_dealloc_page_count
																					, SUM(user_objects_alloc_page_count) AS Task_request_user_objects_alloc_page_count
																					, SUM(user_objects_dealloc_page_count)AS Task_request_user_objects_dealloc_page_count 
																				FROM sys.dm_db_task_space_usage 
																				GROUP BY session_id, request_id) R1 
												INNER JOIN (SELECT session_id
																	, SUM(internal_objects_alloc_page_count) AS Session_request_internal_objects_alloc_page_count
																	, SUM(internal_objects_dealloc_page_count)AS Session_request_internal_objects_dealloc_page_count
																	, SUM(user_objects_alloc_page_count) AS Session_request_user_objects_alloc_page_count
																	, SUM(user_objects_dealloc_page_count)AS Session_request_user_objects_dealloc_page_count 
															 FROM sys.dm_db_Session_space_usage 
															 GROUP BY session_id) R3 
													ON R1.session_id = R3.session_id 
												LEFT OUTER JOIN sys.dm_exec_requests R2 
													ON R1.session_id = R2.session_id 
														AND R1.request_id = R2.request_id
												OUTER APPLY sys.dm_exec_sql_text(R2.sql_handle) AS RL2
												WHERE
														Task_request_internal_objects_alloc_page_count > 0 OR 
														Task_request_internal_objects_dealloc_page_count> 0 OR
														Task_request_user_objects_alloc_page_count > 0 OR
														Task_request_user_objects_dealloc_page_count > 0 OR
														Session_request_internal_objects_alloc_page_count > 0 OR
														Session_request_internal_objects_dealloc_page_count > 0 OR
														Session_request_user_objects_alloc_page_count > 0 OR
														Session_request_user_objects_dealloc_page_count > 0

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Information about potential SQL Injection'
								PRINT '================================================='
								

						/****************************************************************************************************/

									CREATE TABLE #InjectionRisk
										( DBName VARCHAR(200)
										, SPName VARCHAR(200)
										, text   VARCHAR(MAX))
									EXECUTE master.sys.sp_MSforeachdb 'USE [?];
												INSERT #injectionrisk 
													SELECT   DB_NAME()
															,OBJECT_NAME(id)
															, text
													FROM SYSCOMMENTS 
													WHERE ([text] LIKE ''%exec%'' OR text LIKE ''%execute%'') 
														AND OBJECTPROPERTY(id, ''IsProcedure'') = 1  
															AND OBJECT_NAME(id) NOT LIKE ''sp_%'''

									SELECT 'Risk assessment for SQL Injection' AS 'Item', * FROM #InjectionRisk 
									WHERE dbname NOT IN ('master', 'msdb','model', 'tempdb')

									DROP TABLE #InjectionRisk
							
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Information about current SPIDs'
								PRINT '================================================='
								EXEC sp_who2

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT 'Capture current performance counters'
								PRINT ''
								PRINT ''
								PRINT '================================================='
								PRINT 'Performance Counters'
								PRINT '================================================='
								PRINT ''
								SELECT * 
								FROM sys.dm_os_performance_counters 
								WHERE counter_name IN ('Page life expectancy', 'Lock Timeouts/sec', 'Number of Deadlocks/sec'
															, 'Log Growths', 'Active Transactions', 'Commit table entries'
															, 'Failed leaf page cookie', 'Failed leaf page cookie')
