/****************************************************************************************************************************/
/****************************************************************************************************************************/
/****************************************************************************************************************************/

		PRINT ''
		PRINT ''
		PRINT ''
		PRINT '*********************************************************************************'
		PRINT ''
		PRINT ''
		PRINT '       THE FOLLOWING DATA PROVIDES A HIGHLEVEL OVERVIEW OF THE SERVER BEING REVIEWED.'
		PRINT '       COMPLETED BY: ' + SYSTEM_USER
		PRINT '       Security Assessment'
		PRINT '       COMPLETED ON: ' + RTRIM(CONVERT(VARCHAR(20),Getdate(), 101))
		PRINT '	   SERVER NAME: ' +  @@SERVERNAME 
		PRINT '	   NOTE: This may be easier to read if use Notepad,' 
		PRINT '			 with smallest font and turn off word wrap.'
		PRINT ''
		PRINT ''
		PRINT ''
		PRINT ''
		PRINT '*********************************************************************************'

/****************************************************************************************************************************/
/****************************************************************************************************************************/
/****************************************************************************************************************************/
/****************************************************************************************************************************/


BEGIN
			/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Returns SQL Account security settings'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'SQL Account Settings'  AS 'Setting'
										, CONVERT(VARCHAR(50),name) AS 'Name'
										, is_policy_checked
										, is_expiration_checked
										, is_disabled
								FROM master.[sys].[sql_logins]

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Get server role members'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT sys.server_role_members.role_principal_id
										, CONVERT(VARCHAR(50),role.name) AS RoleName
										, sys.server_role_members.member_principal_id
										, member.name AS MemberName  
								FROM sys.server_role_members  
									JOIN sys.server_principals AS role  
										ON sys.server_role_members.role_principal_id = role.principal_id  
									JOIN sys.server_principals AS member  
										ON sys.server_role_members.member_principal_id = member.principal_id;

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Get server role, fixed and custom'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Server Roles' AS 'Setting'
										, CONVERT(VARCHAR(50),name) AS 'Name'
								FROM sys.server_principals 
								WHERE type = 'R' ;  

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Lists all the members of the server roles'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								EXEC master..sp_helpsrvrolemember


						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Returns the members of the Database roles for all databases'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								DECLARE @name sysname,@sql1 nvarchar(4000),@maxlen1 smallint,@maxlen2 smallint,@maxlen3 smallint



								CREATE TABLE #tmpTable 
								(
								 DBName sysname NOT NULL ,
								 UserName sysname NOT NULL,
								 RoleName sysname NOT NULL
								)

								DECLARE c1 CURSOR for 
								 SELECT name FROM master.sys.databases where state_desc <> 'Offline'

								OPEN c1
								FETCH c1 INTO @name
								WHILE @@FETCH_STATUS >= 0
								BEGIN
								 SELECT @sql1 = 
												 'INSERT INTO #tmpTable
												 SELECT N'''+ @name + ''', a.name, c.name
												 FROM [' + @name + '].sys.database_principals a 
												 JOIN [' + @name + '].sys.database_role_members b ON b.member_principal_id = a.principal_id
												 JOIN [' + @name + '].sys.database_principals c ON c.principal_id = b.role_principal_id
												 WHERE a.name != ''dbo'''
								 EXECUTE (@sql1)
								 FETCH c1 INTO @name
								END
								CLOSE c1
								DEALLOCATE c1

								SELECT @maxlen1 = (MAX(LEN(COALESCE(DBName, 'NULL'))) + 2)
								FROM #tmpTable

								SELECT @maxlen2 = (MAX(LEN(COALESCE(UserName, 'NULL'))) + 2)
								FROM #tmpTable

								SELECT @maxlen3 = (MAX(LEN(COALESCE(RoleName, 'NULL'))) + 2)
								FROM #tmpTable

								SET @sql1 = 'SELECT ''Database Role Members'', LEFT(DBName, ' + LTRIM(STR(@maxlen1)) + ') AS ''DB Name'', '
								SET @sql1 = @sql1 + 'LEFT(UserName, ' + LTRIM(STR(@maxlen2)) + ') AS ''User Name'', '
								SET @sql1 = @sql1 + 'LEFT(RoleName, ' + LTRIM(STR(@maxlen3)) + ') AS ''Role Name'' '
								SET @sql1 = @sql1 + 'FROM #tmpTable '
								SET @sql1 = @sql1 + 'ORDER BY DBName, UserName'
								EXEC(@sql1)

								DROP TABLE #tmpTable

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Returns all database users'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								DECLARE @DB_USers TABLE
								(TypeOfAudit VARCHAR(50), DBName sysname, UserName sysname null, LoginType sysname, AssociatedRole varchar(max))
 
								INSERT @DB_USers
								EXEC sp_MSforeachdb
 
										'
										use [?]
										SELECT ''Database User Audit'',
											''?'' AS DB_Name,
										case prin.name when ''dbo'' then prin.name + '' (''+ (select SUSER_SNAME(owner_sid) from master.sys.databases where name =''?'') + '')'' else prin.name end AS UserName,
										prin.type_desc AS LoginType,
										isnull(USER_NAME(mem.role_principal_id),'''') AS AssociatedRole 
										FROM sys.database_principals prin
										LEFT OUTER JOIN sys.database_role_members mem ON prin.principal_id=mem.member_principal_id
										WHERE prin.sid IS NOT NULL and prin.sid NOT IN (0x00) and
										prin.is_fixed_role <> 1 AND prin.name NOT LIKE ''##%'''
 
								SELECT
									  TypeOfAudit  AS 'Setting'
									, CONVERT(VARCHAR(50),DBName) AS 'DBName'
									, CONVERT(VARCHAR(50),UserName) AS 'User Name'
									, CONVERT(VARCHAR(50),LoginType) as 'Login Type'
									,
										STUFF(
										(
										SELECT ',' + CONVERT(VARCHAR(500),AssociatedRole)
								FROM @DB_USers user2
								WHERE user1.DBName=user2.DBName AND user1.UserName=user2.UserName
 
								FOR XML PATH('')
								)
								,1,1,'') AS Permissions_user
								FROM @DB_USers user1
								GROUP BY TypeOfAudit, DBName,UserName ,LoginType 
								ORDER BY DBName,UserName


						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Returns the server level permissions, other than Connect SQL'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Server Level Permissions'  AS 'Setting'
											, [srvprin].[name] [server_principal]
											, [srvprin].[type_desc] [principal_type]
											, [srvperm].[permission_name]
											, [srvperm].[state_desc]  
								FROM master.[sys].[server_permissions] srvperm 
										INNER JOIN master.[sys].[server_principals] srvprin 
												ON [srvperm].[grantee_principal_id] = [srvprin].[principal_id] 
								WHERE [srvprin].[type] IN ('S', 'U', 'G') 
										AND [srvperm].[permission_name] <> 'CONNECT SQL'
								ORDER BY [server_principal], [permission_name]


						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Account Password Issues'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								 SELECT   'Password Audit'  AS 'Setting', l.name
												, l.create_date
												, l.modify_date
												,'Type 1' AS 'Type Of Problem'
								FROM master.sys.sql_logins l
								WHERE PWDCOMPARE(name,password_hash)=1
								UNION ALL
								SELECT    'Password Audit'  AS 'Setting', l.name
												, l.create_date
												, l.modify_date
												, 'Type 2'
								FROM master.sys.sql_logins l
								WHERE PWDCOMPARE('',password_hash)=1
								If @@Rowcount = 0
									BEGIN
										Select 'All SQL accounts Pass the Password check' AS 'Status'
									END

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Gets credential Info'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Credential Info'  AS 'Setting'
										, Name
										, credential_identity  
								FROM master.sys.credentials
								IF @@Rowcount = 0
									BEGIN
										SELECT 'No Credentials found' AS 'Status'
									END

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'SA account audit'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'SA Account Audit'  AS 'Setting', l.name
										, CASE WHEN l.name = 'sa' THEN 'NO' ELSE 'YES' END as Renamed
										, CASE WHEN s.is_policy_checked = 0 THEN 'NO' ELSE 'YES' END AS 'is_policy_checked'
										, CASE WHEN s.is_expiration_checked = 0 THEN 'NO' ELSE 'YES' END AS 'is_expiration_checked'
										, CASE WHEN  l.is_disabled = 0 THEN 'NO' ELSE 'YES' END AS 'is_disabled'
										, l.Modify_date
								FROM master.sys.server_principals AS l
									LEFT OUTER JOIN master.sys.sql_logins AS s ON s.principal_id = l.principal_id
								WHERE l.sid = 0x01


PRINT '========================================================================================================================='
							PRINT ''
							PRINT ''
							PRINT 'Gets the SQL Account status'

							SET NOCOUNT ON
							PRINT ''
							PRINT ''

								SELECT  'SQL Login Account Status' As 'Information'
										, name
										,LOGINPROPERTY(name, 'BadPasswordCount') AS 'BadPasswordCount'
										,LOGINPROPERTY(name, 'BadPasswordTime') AS 'BadPasswordTime'
										,LOGINPROPERTY(name, 'DaysUntilExpiration') AS 'DaysUntilExpiration'
										,LOGINPROPERTY(name, 'DefaultDatabase') AS 'DefaultDatabase'
										,LOGINPROPERTY(name, 'DefaultLanguage') AS 'DefaultLanguage'
										,LOGINPROPERTY(name, 'HistoryLength') AS 'HistoryLength'
										,LOGINPROPERTY(name, 'IsExpired') AS 'IsExpired'
										,LOGINPROPERTY(name, 'IsLocked') AS 'IsLocked'
										,LOGINPROPERTY(name, 'IsMustChange') AS 'IsMustChange'
										,LOGINPROPERTY(name, 'LockoutTime') AS 'LockoutTime'
										,LOGINPROPERTY(name, 'PasswordLastSetTime') AS 'PasswordLastSetTime'
										,is_expiration_checked	As 'is_expiration_checked'
								FROM    sys.sql_logins


						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Gets the failed logins from the currently error log'

								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								EXEC sp_readerrorlog 0, 1, 'Login failed'
								IF @@ROWCOUNT = 0
									BEGIN
										PRINT 'No Failed Logins were found.'
									END

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Certificate Information'
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Certificate Information' AS 'Status'
									   , * 
								FROM sys.certificates

								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''

						
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Symmetric Key Information'
								PRINT ''
								PRINT ''
								PRINT ''

								SELECT 'Symmetric Key Information' AS 'Status'
									   , * 
								FROM sys.symmetric_keys

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Symmetric Key Information'
								PRINT ''
								PRINT ''
								PRINT ''


								SELECT 'Asymmetric Key Information' AS 'Status'
									   ,* 
								FROM sys.asymmetric_keys

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Database Encryption Key Information'
								PRINT ''
								PRINT ''
								PRINT ''

								SELECT 'Database Encryption Key Information' AS 'Status'
								       , * 
								FROM sys.dm_database_encryption_keys

								IF @@ROWCOUNT = 0
									BEGIN
										PRINT 'No database encryption keys found.'
									END




						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Always Encryption'
								PRINT ''
								PRINT ''
								PRINT ''

								SELECT 'Database Encryption Key Information' AS 'Status'
								       , * 
								FROM sys.dm_database_encryption_keys

								IF @@ROWCOUNT = 0
									BEGIN
										PRINT 'No database encryption keys found.'
									END

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Find embedded email addresses in job steps'
								PRINT ''
								PRINT ''
								PRINT ''
								USE [msdb]
		
								SELECT	'Email Addresses in Job Steps'  AS 'Setting',
									s.srvname,
									j.name,
									js.step_id,
									j.enabled 
								FROM	msdb.dbo.sysjobs j
								JOIN	msdb.dbo.sysjobsteps js
									ON	js.job_id = j.job_id 
								JOIN	master.dbo.sysservers s
									ON	s.srvid = j.originating_server_id
								WHERE	js.command LIKE N'%@%.com%'
											OR js.command LIKE N'%@%.edu%'
											OR js.command LIKE N'%@%.org%'


								If @@Rowcount = 0
									BEGIN
										Select 'No email address found in Job Steps' AS 'Status'
									END

END